<?php

/**
* Data Transaction / MySQL Plugin
* A MySQL plugin to the (data_trans) class
* @package		phpOpenFW
* @subpackage 	Database_Tools
* @author 		Christian J. Clark
* @copyright	Copyright (c) Christian J. Clark
* @license		http://www.gnu.org/licenses/gpl-2.0.txt
* @access		private
* @version 		Started: 2-1-2007 updated: 1-20-2010
*/

//***************************************************************
/**
 * dt_mysql Class
 * @package		phpOpenFW
 * @subpackage	Database_Tools
 * @access		private
 */
//***************************************************************
class dt_mysql extends dt_structure
{

    /**
	* Opens a connection to the specified data source based on the data source type
	**/
	//*************************************************************************
	// Make a connection to the given source and store the handle
	//*************************************************************************
	public function open()
	{
		$host = $this->server;
		if (!empty($this->port)) { $host .= ':' . $this->port; }
        $this->handle = @mysql_connect($host, $this->user, $this->pass);

        if (!$this->handle || mysql_errno()) {
            $this->connection_error(mysql_error());
            return false;
        }
        else {
			// Select Database
        	@mysql_select_db($this->source, $this->handle);

			if (mysql_errno()) {
				$this->gen_error(mysql_error());
				return false;
			}
			else {
				// Flag Connection as Open       
		        $this->conn_open = true;
		        return true;
			}
		}
	}
	
	/**
	* Closes a connection to the specified data source based on the data source type
	**/
	//*************************************************************************
	// Close the connection to the data source
	//*************************************************************************
    public function close()
	{
		if ($this->handle) { mysql_close($this->handle); }
		$this->conn_open = false;
	}

	/**
	* Executes a query based on the data source type
	* @param mixed MySQL: SQL Statement
	**/
	//*************************************************************************
	// Execute a query and store the record set
	//*************************************************************************
	public function query($query)
	{
		// Check for Open Connection
		if (!$this->is_open()) { return false; }

        $this->rsrc_id = mysql_query($query);
        if ($this->rsrc_id && gettype($this->rsrc_id) != 'boolean') {
            $this->num_rows = mysql_num_rows($this->rsrc_id);
            while($row=mysql_fetch_assoc($this->rsrc_id)){
                array_push($this->result, $row);
            }
        }

        // Last Insert ID
        $this->last_id = mysql_insert_id();

        // MySQL Error Reporting
        if ($mysql_error=mysql_error()) { $this->gen_error($mysql_error); }
	}

}

?>
